

// SYSTEM INCLUDES
#include <iostream>
#include <map>
#include <vector>
#include <string>

// PROJECT INCLUDES

#include "EnvironmentEnvironmentHandler"

// LOCAL INCLUDES

// FORWARD REFERENCES

/*
*	COMMENT
*	@param
*	@return
*/
#ifndef __EnvironmentHandler_h__INCLUDED
template <class P>

class EnvironmentHandler
	{
				public:
						//====== LIFECYCLE ========
						EnvironmentHandler(SomeEnvironment<P>* environment);
						~EnvironmentHandler();
													
						//====== OPERATIONS =======
						/*
						* change the actual intants associated to the
						* names given
						*/
						void nextInstants(std::vector<std::string> nameConcepts);
						
						/*
						* adds an actual	Instant to a concept, it means, this instant
						* has all index fixed, except the index in the instant of the concept
						* identified by nameConcept
						*/
						void addActualInstantOfCOncept(std::string nameConcept,Instant* instant);
						
						/*
						* removes the  pair in the map of actual concepts
						*/
						void removeActualInstantOfConcept(std::string nameConcept);
						
						//====== INQUIRY =========
						/*
						* get all the actual instants
						*/
						void getActualsInstants(std::vector<Instant*>& instantsVector);
						
						/*
						* get the actual instant fot the concept identified by the name
						*/
						Instant* getActualInstant(std::string nameConcept);
						//====== ACCESS ==========
					
						

						
				private:
					
					//======= ATTRIBUTES=======
					
					/*
					*	actual instants of the environmenHandler
					*/
					
					std::map<std::string,Instant*>		actualInstants;
					/*
					*	Environment that's being handled
					*/
				
					SomeEnvironment<P>* environment;
					//====== PRIVATE METHODS=========
				
							
	};
//include the implementation of the template
#include "EnvironmentHandler_Txx.h"
#endif
